/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

#ifndef _DATAITEMPARENTHESIZEDEXPR_HPP
#define _DATAITEMPARENTHESIZEDEXPR_HPP

#include <pathan/Pathan.hpp>

#include <pathan/dataItem/DataItemImpl.hpp>

class PATHAN_EXPORT DataItemParenthesizedExpr : public DataItemImpl
{

public:
  DataItemParenthesizedExpr(XPath2MemoryManager* memMgr);	

  ///adds a dataitem to this DataItemParenthesizedExpr
  void addItem(DataItem* di);

  //collapse the compiled expression based on context
  virtual Sequence collapseTreeInternal(DynamicContext* context, int flags=0) const;

  virtual DataItem* staticResolution(StaticContext *context, StaticResolutionContext *src);

  const VectorOfDataItems &getChildren() const;

private:
	VectorOfDataItems _dataItems;
};

#endif
