/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

/*

  Subsequence function -- Returns the subsequence of a given sequence identified by location 

*/

#ifndef _FUNCTIONSUBSEQUENCE_HPP
#define _FUNCTIONSUBSEQUENCE_HPP

#include <pathan/Pathan.hpp>

#include <pathan/functionAPI/ConstantFoldingFunction.hpp>

/** Subsequence function. */
class PATHAN_EXPORT FunctionSubsequence : public ConstantFoldingFunction
{
public:
  static const XMLCh name[];

  FunctionSubsequence(const VectorOfDataItems &args, XPath2MemoryManager* memMgr);
  
  /** Returns the contiguous subsequence of items in the value of param1 beginning at the position to the right of param2 
   *  and continuing for the number of items indicated by param3 **/
  Sequence collapseTreeInternal(DynamicContext* context, int flags=0) const;

};

#endif // _FUNCTIONSUBSEQUENCE_HPP





