/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

/*
   GreaterThanEqual operator function
*/

#ifndef _GREATERTHANEQUAL_HPP
#define _GREATERTHANEQUAL_HPP

#include <pathan/Pathan.hpp>

#include <pathan/dataItem/DataItemOperator.hpp>

/** OpGreaterThanEqual operator function*/
class PATHAN_EXPORT GreaterThanEqual : public DataItemOperator
{
public:
  static const XMLCh name[];

  GreaterThanEqual(const VectorOfDataItems &args, XPath2MemoryManager* memMgr);
  
  static bool greater_than_equal(const Item* arg1, const Item* arg2, DynamicContext* context);

  /** OpGreaterThanEqual Takes two DataItems a and b and returns (a < b)*/
  Sequence collapseTreeInternal(DynamicContext* context, int flags=0) const;

};

#endif // _GREATERTHANEQUAL_HPP

