/*
 * Copyright (c) 2001, DecisionSoft Limited All rights reserved.
 * Please see LICENSE.TXT for more information.
 */

/*
   LessThan operator function
*/

#ifndef _LESSTHAN_HPP
#define _LESSTHAN_HPP

#include <pathan/Pathan.hpp>

#include <pathan/dataItem/DataItemOperator.hpp>

/** OpLessThan operator function*/
class PATHAN_EXPORT LessThan : public DataItemOperator
{
public:
  static const XMLCh name[];

  LessThan(const VectorOfDataItems &args, XPath2MemoryManager* memMgr);
  
  static bool less_than(const Item* arg1, const Item* arg2, DynamicContext* context);

  /** OpLessThan Takes two DataItems a and b and returns (a < b)*/
  Sequence collapseTreeInternal(DynamicContext* context, int flags=0) const;

};

#endif // _LESSTHAN_HPP

